$ goto runide_start
$!*****************************************************************************
$!                                                                            *
$!                        Sun Public License Notice                           *
$!                                                                            *
$! The contents of this file are subject to the Sun Public License Version    *
$! 1.0 (the "License"). You may not use this file except in compliance with   *
$! the License. A copy of the License is available at http://www.sun.com/     *
$!                                                                            *
$!                                                                            *
$! The Original Code is the NetBeans IDE launcher for OpenVMS.                *
$! The Initial Developer of the Original Code is Compaq Computer Corporation. *
$! Portions created by Compaq Computer Corporation are Copyright (C) 2001.    *
$! All Rights Reserved.                                                       *
$!                                                                            *
$! Contributor(s): Compaq Computer Corporation.                               *
$!                                                                            *
$!*****************************************************************************
$!                                                                            *
$! If you have a problem or comment on this program, please send it to:       *
$!                                                                            *
$!                            NetBeans@compaq.com                             *
$!                                                                            *
$!*****************************************************************************
$!                                                                            *
$! OpenVMS NetBeans multiuser IDE launcher                                    *
$!                                                                            *
$!   Format:                                                                  *
$!                                                                            *
$!     @RUNIDEOPENVMS [userdir] [args1] [args2]                               *
$!                                                                            *
$!   Arguments:                                                               *
$!                                                                            *
$!     userdir                                                                *
$!                                                                            *
$!     VMS directory specification which will be used as the home directory   *
$!     for NetBeans user-specific files                                       *
$!                                                                            *
$!     args1                                                                  *
$!                                                                            *
$!     List of switches that will be passed to the Java Virtual Machine. You  *
$!     also specify NetBeans properties (e.g. -Dnetbeans.policy) here.        *
$!                                                                            *
$!     If the list contains more than one value or has lowercase characters   *
$!     which must be preserved, it must be enclosed within "". If the value   *
$!     contains a directory specification, it must be in Unix-style format    *
$!     (i.e. /dev/dir0/dir1/.../file.ext).                                    *
$!                                                                            *
$!     args2                                                                  *
$!                                                                            *
$!     List of switches that will be passed to the NetBeans IDE.              *
$!                                                                            *
$!     If the list contains more than one value or has lowercase characters   *
$!     which must be preserved, it must be enclosed within "". If the value   *
$!     contains a directory specification, it must be in Unix-style format    *
$!     (i.e. /dev/dir0/dir1/.../file.ext).                                    *
$!                                                                            *
$!     Description                                                            *
$!                                                                            *
$!     This command procedure is used to start the NetBeans IDE on an OpenVMS *
$!     system.                                                                *
$!                                                                            *
$!     There are several requirements for this program to work properly:      *
$!                                                                            *
$!         - RUNIDEOPENVMS.COM must either reside in the NetBeans bin         *
$!           directory and run from there                                     *
$!                                                                            *
$!           or                                                               *
$!                                                                            *
$!           The logical name NETBEANS$HOME must be defined with a string     *
$!           that points to the directory where NetBeans is installed         *
$!                                                                            *
$!           or                                                               *
$!                                                                            *
$!           You must specify the NetBeans property "netbeans.home=" on the   *
$!           command line with an appropriate directory path in Unix format   *
$!           (e.g. @RUNIDEOPENVMS "" "-Dnetbeans.home=/dev/netbeans/")        *
$!                                                                            *
$!         _ The jdk for OpenVMS should be installed in SYS$COMMON:[JAVA$130] *
$!                                                                            *
$!           or                                                               *
$!                                                                            *
$!           The logical name JDK$HOME must be defined with a string that     *
$!           points to the directory where the jdk is installed               *
$!                                                                            *
$!         - User process quotas must be sufficient                           *
$!                                                                            *
$!         - The CHANNELCNT sysgen value should be at least 2000              *
$!                                                                            *
$!     Examples:                                                              *
$!                                                                            *
$!         @RUNIDEOPENVMS USER$:[MYACCOUNT.NETBEANS]                          *
$!                                                                            *
$!         Starts NetBeans with the specified user directory. If the required *
$!         directory structure and files do not exist, the user is asked if   *
$!         they should be created.                                            *
$!                                                                            *
$!         @RUNIDEOPENVMS "" "" "-fontsize 14"                                *
$!                                                                            *
$!         Starts NetBeans using a fontsize of 14. Note that null arguments   *
$!         ("") are required as placeholders and the quotes around the        *
$!         specified argument are optional for this example.                  *
$!                                                                            *
$!*****************************************************************************
$
$runide_start:
$
$ saved_verify = f$verify()
$ on error then goto error_handler
$ on control_y then goto done
$
$! Constants
$ min_astlm = 300
$ min_biolm = 1024
$ min_bytlm = 2000000
$ min_diolm = 1024
$ min_enqlm = 2000
$ min_fillm = 300
$ min_jtquota = 60000
$ min_pgflquota = 1500000
$ min_prclm = 10
$ min_tqelm = 400
$ min_wsextent = 524288
$
$! Initialize variables
$ nb$cp1 == ""
$ nb$cp2 == ""
$ nb$cp3 == ""
$ nb$cp4 == ""
$ nb$cp5 == ""
$ nb$cp6 == ""
$ nb$cp7 == ""
$ nb$cp8 == ""
$ nb$cp9 == ""
$ nb$cp10 == ""
$
$! Define the NetBeans IDE entry point
$ ide = "org.netbeans.Main"
$
$! Define the NetBeans updater entry point
$ updater = "org.netbeans.updater.UpdaterFrame"
$
$! JDKHOME should point to the base directory of a kit, and is used
$! to locate things like tools.jar
$ jdkhome = f$trnlnm("JDK$HOME")
$ if jdkhome .eqs. ""
$ then
$   jdkhome = "sys$common:[java$130]"
$ endif
$
$! Create the path to the NetBeans kit. If the NETBEANS$HOME logical is
$! defined, use its value as the NetBeans kit path. If not defined, assume
$! this command file is executed from one level below the NetBeans root
$! directory (typically device:[top_level_dir.netbeans.bin]). Determine the
$! kit's path from there.
$ nbhome = f$trnlnm("NETBEANS$HOME")
$ if nbhome .eqs. ""
$ then
$   nbhome_ = f$env("PROCEDURE")
$   nbhome_ = F$PARSE(nbhome_,,,"DEVICE") + F$PARSE(nbhome_,,,"DIRECTORY")
$   nbhome__ = nbhome_
$   nbhome_ = nbhome_ - "]" + ".-]"
$   nbhome = F$PARSE(nbhome_,,,"DEVICE") + F$PARSE(nbhome_,,,"DIRECTORY")
$ endif
$
$! Convert the NetBeans kit path to unix format
$ call convert_to_unix 'nbhome' "unix_nbhome"
$
$! Check to make sure that some critical quotas for running NetBeans are
$! sufficient and warn the user if any are not
$ error_count == 0
$ call check_quota "ASTLM" min_astlm error_count
$ call check_quota "BIOLM" min_biolm error_count
$ call check_quota "BYTLM" min_bytlm error_count
$ call check_quota "DIOLM" min_diolm error_count
$ call check_quota "ENQLM" min_enqlm error_count
$ call check_quota "FILLM" min_fillm error_count
$ call check_quota "PGFLQUOTA" min_pgflquota error_count
$ call check_quota "PRCLM" min_prclm error_count
$ call check_quota "TQLM" min_tqelm error_count
$ call check_quota "WSEXTENT" min_wsextent error_count
$ if error_count .ne. 0
$ then
$   write sys$output ""
$   write sys$output "Warning:  NetBeans may not start or work properly until all quotas are"
$   write sys$output "          set to at least their recommended minimum values.
$   write sys$output ""
$ endif
$
$! Determine the user's NetBeans directory tree and create it if necessary
$ vms_userdir = ""
$ if P1 .nes. ""
$ then
$!  User directory was specified on the command line
$   tmp_userdir = P1
$ else
$   tmp_userdir = f$trnlnm("NETBEANS$USER")
$   if tmp_userdir .nes. ""
$   then
$!    Base user directory was specified in the logical NETBEANS$USER
$     tmp_userdir = tmp_userdir - "]" + "." +-
                    f$edit(f$getjpi("", "USERNAME"), "TRIM") + "]"
$   endif
$ endif
$ call check_userdir "userdir" 'tmp_userdir'
$ if userdir .eqs. "" then goto done
$ write sys$output "Using ''userdir' as user directory..."
$ call convert_to_unix 'userdir' "unix_userdir"
$
$restart:
$
$! Create the JVM command file
$ userpid = f$getjpi("", "PID")
$ cmd_filename = userdir + "nb_cmd-" + userpid + ".dat"
$ open/write cmd_file 'cmd_filename'
$
$! Create the classpath and write it to the command file
$ nb$cp1 = unix_userdir + "/lib:" + unix_nbhome + "/lib:"
$ call find_jars userdir "lib.patches" "nb$cp2"
$ call find_jars nbhome "lib.patches.locale" "nb$cp3"
$ call find_jars nbhome "lib.patches" "nb$cp4"
$ call find_jars nbhome "lib.ext.locale" "nb$cp5"
$ call find_jars userdir "lib.ext" "nb$cp6"
$ call find_jars nbhome "lib.ext" "nb$cp7"
$ call find_jars nbhome "lib.locale" "nb$cp8"
$ call find_jars nbhome "lib" "nb$cp9"
$ call find_jars jdkhome "lib..." "nb$cp10"
$ write/symbol cmd_file "-cp ", nb$cp1, nb$cp2, nb$cp3, nb$cp4, nb$cp5, -
                                nb$cp6, nb$cp7, nb$cp8, nb$cp9, nb$cp10
$
$! Add the memory switches for the VM to the command file
$ write cmd_file "-Xms8m"
$ max_heap = f$getjpi("", "WSEXTENT") / 2048
$ if max_heap .gt. 200 then max_heap = 200
$ write cmd_file "-Xmx''max_heap'm"
$
$! NetBeans user directory property
$ write cmd_file "-Dnetbeans.user=", unix_userdir
$
$! NetBeans home directory property
$ write cmd_file "-Dnetbeans.home=", unix_nbhome
$
$! NetBeans security property
$ write cmd_file "-Djava.security.policy=", unix_nbhome, "/bin/ide.policy"
$
$! Start the NetBeans IDE
$ write sys$output "Starting NetBeans..."
$ close cmd_file
$! The JVM will hang if verify is on, so shut it off but save the current state
$ saved_verify = f$verify(0)
$! NetBeans will exit with a status of 66 if a module was added through the
$! (auto)Update Center. Since OpenVMS interprets this value as an error (and
$! consequently transfers control to the error handler), we must turn off
$! "on error" handling temporarily
$ set noon
$ java -V 'userdir'nb_cmd-'userpid'.dat 'P2' 'ide' 'P3'
$
$! If the exit status is 66, we need to run the IDE updater and then restart
$! the IDE
$ if $status .eq. %x10000042
$ then
$   on error then goto error_handler
$   java -V 'userdir'nb_cmd-'userpid'.dat 'P2' 'updater' 'P3'
$   goto restart
$ endif
$
$! Finished. Delete the command files, perform some clean up, restore the
$! verify state and exit
$done:
$ if f$search("''cmd_filename'", 1) .nes. ""
$ then
$   delete 'cmd_filename';*
$ endif
$ modules_dir = userdir - "]" + ".modules]"
$ if f$search("''modules_dir'installedModules.xml", 1) .nes. ""
$ then
$   purge 'modules_dir'installedModules.xml
$ endif
$ if f$search("''modules_dir'externalizedModules.ser", 1) .nes. ""
$ then
$   purge 'modules_dir'externalizedModules.ser
$ endif
$ saved_verify = f$verify('saved_verify')
$ exit
$
$! Deal with any errors. Simply let the user know something went wrong and
$! display the status code
$!
$error_handler:
$ write sys$output "An error occurred; exit status = ", $status
$ goto done
$
$! Subroutines:
$!
$
$! Look for .jar and .zip files down the tree pointed to by P1 and P2.
$! The result is returned in the symbol named by P3
$!
$find_jars: subroutine
$ h = 'P1 - "]"
$top1:
$ x = f$search("''h'.''P2']*.jar", 1)
$ if x .nes. ""
$ then
$   vfs = f$parse(x,,,"DEVICE") + f$parse(x,,,"DIRECTORY") +-
          f$parse(x,,,"NAME") + f$parse(x,,,"TYPE")
$   call convert_to_unix 'vfs "ufs"
$   'P3 == 'P3 + ufs + ":"
$   goto top1
$ endif
$top2:
$ x = f$search("''h'.''P2']*.zip", 1)
$ if x .nes. ""
$ then
$   y = f$parse(x,,,"DEVICE") + f$parse(x,,,"DIRECTORY") +-
        f$parse(x,,,"NAME") + f$parse(x,,,"TYPE")
$   'P3 == ":" + 'P3 + "''y'"
$   goto top2
$ endif
$ return
$ endsubroutine
$
$! This is a very simple routine to convert from a VMS style filespec to
$! a Unix style filespec.  The VMS filespec is passed in P2 and the Unix
$! filespec result is returned in the symbol named by P1
$!
$convert_to_unix: subroutine
$ x = P1
$ du = "/" + f$parse(x,,,"DEVICE") - ":"
$ d = f$parse(x,,,"DIRECTORY") - "[" - "]" - "<" - ">"
$ count = 0
$cu_top:
$ e = f$element(count, ".", d)
$ if e .eqs. "." then goto cu_bottom
$ du = du + "/" + e
$ count = count + 1
$ goto cu_top
$cu_bottom:
$ f = f$parse(x,,,"NAME") + f$parse(x,,,"TYPE")
$ if f .nes. "."
$ then
$   du = du + "/" + f
$ endif
$ 'P2 == du
$ return
$ endsubroutine
$
$! Determine the user directory and create the directory tree if necessary
$!
$check_userdir: subroutine
$! Determine the NetBeans user directory
$ if P2 .nes. ""
$ then
$    userdir = P2
$ else
$    userdir = f$trnlnm("sys$login") - "]" + ".nbuser]"
$ endif
$! If the directory tree doesn't exist, create it
$ if f$search("''userdir'system.dir") .eqs. ""
$   then
$     write sys$output "User directory ''userdir' does not exist"
$     inquire continue "Do you want to create it? [N]"
$     if .not. continue
$     then
$       userdir = ""
$       goto skip
$     endif
$! --- COMMENTING OUT THIS SECTION --- (jglick 03/09/2001)
$!     write sys$output "Setting up this user for the NetBeans IDE..."
$!     create/dir 'userdir'
$!     ud = userdir - "]"
$!     hd = nbhome - "]"
$!!    Only copy the examples and tutorials if the user wants them
$!     inquire continue "Do you want the NetBeans example and tutorial files? [N]"
$!     if .not. continue
$!     then
$!       create/dir 'ud'.Development]       
$!     else
$!       backup/nolog 'hd'.Development...]*.*;0 'ud'.Development...]
$!     endif
$!!
$!     create/dir 'ud'.system]/prot=o:rwed
$!     create 'ud'.system]project.last_hidden
$!     create 'ud'.system]project.basic_hidden
$!     create/dir 'ud'.system.Projects]
$!     create 'ud'.system.Projects]workspace.ser_hidden
$!!
$!     create/dir 'ud'.modules]
$!     create/dir 'ud'.lib]
$!     create/dir 'ud'.lib.ext]
$!     create/dir 'ud'.lib.patches]
$! --- END OF COMMENTED-OUT SECTION ---
$ endif
$skip:
$ 'P1' == userdir
$ return
$ endsubroutine
$
$! Test a particular process quota against a minimum value. If the quota is
$! not at least the minimum value, display a warning message to the user.
$!
$! P1 is a string that is the name of the quota and P2 is the minimum value
$! for that the quota. The symbol named in P3 is incremented if the specified
$! quota is below the minimum value.
$!
$check_quota: subroutine
$ quota_val = f$getjpi("","''P1'")
$ if quota_val .lt. 'P2'
$ then
$   write sys$output "The ''P1' quota for your process is too low"
$   write sys$output "    Actual: ''quota_val'; recommended minimum: ", 'P2'
$   'P3' == 'P3' + 1
$ endif
$ return
$ endsubroutine
$
$!*****************************************************************************
$!                                                                            *
$! Change history:                                                            *
$!                                                                            *
$! 03/08/2001 - Fixed a problem that was preventing the updater from running  *
$!              and added a loop to restart the IDE after an update.          *
$!                                                                            *
$! 03/01/2001 - Added some quota checks and the ability to pass arguments on  *
$!              the command line to the JVM and NetBeans.                     *
$!                                                                            *
$! 02/23/2001 - The home directory of the JDK and the NetBeans kits can now   *
$!              be defined with the logical names JDK$HOME and                *
$!              NETBEANS$HOME respectively.                                   *
$!                                                                            *
$! 02/22/2001 - All JVM commands are now written to a file and the VM is      *
$!              started with the "-V filname" switch. This change was made    *
$!              to enable a classpath up to 2048 characters in length.        *
$!                                                                            *
$!              The user directory is now determined in the following         *
$!              sequence:                                                     *
$!                                                                            *
$!                  1) If an argument was entered on the command line, it is  *
$!                     assumed to be the user directory specification         * 
$!                                                                            *
$!                  2) If no argument was entered, the logical name           *
$!                     NETBEANS$USERS is checked. If this logical is defined, *
$!                     its value is used as the root directory of where       *
$!                     the NetBeans user files are kept. To differentiate     *
$!                     this particular user, the current user's account name  *
$!                     is appended to the value of NETBEANS$USERS.            *
$!                                                                            *
$!                  3) If neither of the above conditions is met, NBUSER is   *
$!                     appended to the value of SYS$LOGIN and that is used as *
$!                     the user directory.                                    *
$!                                                                            *
$! 02/21/2001 - Reduced the initial and maximum heap size arguments to the VM *
$!              to force more frequent garbage collection. This is a work-    *
$!              around to fix a VM assert error which cropped up in newer     *
$!              NetBeans development builds.                                  *
$!                                                                            *
$!*****************************************************************************
