/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package vcs.commands;

import java.util.*;
import javax.swing.table.*;
import javax.swing.*;

import org.openide.*;

import org.netbeans.modules.vcscore.util.*;

/**
 *
 * @author  Martin Entlicher
 */
public class CvsModuleSelectorDialog extends javax.swing.JDialog {

    private Vector modules = null;
    private boolean validSelection = false;
    //private volatile InformationDialog waitDlg = null;
    private javax.swing.ButtonGroup bg;


    static final long serialVersionUID = 1987612235843595460L;
    /** Creates new form CvsModuleSelectorDialog */
    public CvsModuleSelectorDialog(java.awt.Frame parent,boolean modal) {
        super (parent, modal);
        initComponents ();
        tblModules.getTableHeader().setReorderingAllowed(true);
        javax.swing.ButtonGroup bg = new javax.swing.ButtonGroup ();
        bg.add (rbCheckoutModule);
        bg.add (rbIgnore);

        setTitle(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.title"));
        pack ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        statusLabel = new javax.swing.JLabel();
        listScrollPane = new javax.swing.JScrollPane();
        tblModules = new javax.swing.JTable();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        lblWarning = new javax.swing.JLabel();
        lblOptions = new javax.swing.JLabel();
        rbCheckoutModule = new javax.swing.JRadioButton();
        rbIgnore = new javax.swing.JRadioButton();
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        }
        );
        
        statusLabel.setText("kuk");
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(8, 8, 0, 8);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        getContentPane().add(statusLabel, gridBagConstraints1);
        
        
        
        tblModules.setShowVerticalLines(false);
        tblModules.setPreferredScrollableViewportSize(new java.awt.Dimension(300, 200));
        tblModules.setShowHorizontalLines(false);
        listScrollPane.setViewportView(tblModules);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(8, 8, 8, 8);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        getContentPane().add(listScrollPane, gridBagConstraints1);
        
        
        okButton.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.okButton.text"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.insets = new java.awt.Insets(0, 8, 8, 0);
        gridBagConstraints1.weightx = 1.0;
        getContentPane().add(okButton, gridBagConstraints1);
        
        
        cancelButton.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.cancelButton.text"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 8, 8);
        gridBagConstraints1.weightx = 1.0;
        getContentPane().add(cancelButton, gridBagConstraints1);
        
        
        lblWarning.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.lbWarning.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 2;
        getContentPane().add(lblWarning, gridBagConstraints1);
        
        
        lblOptions.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.lblOptions.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        getContentPane().add(lblOptions, gridBagConstraints1);
        
        
        rbCheckoutModule.setSelected(true);
        rbCheckoutModule.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.rbCheckoutModule.text"));
        rbCheckoutModule.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbCheckoutModuleActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(rbCheckoutModule, gridBagConstraints1);
        
        
        rbIgnore.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.rbIgnore.text"));
        rbIgnore.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbIgnoreActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(rbIgnore, gridBagConstraints1);
        
    }//GEN-END:initComponents

  private void rbIgnoreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbIgnoreActionPerformed
// Add your handling code here:
      tblModules.setEnabled(false);
      tblModules.getSelectionModel().clearSelection();
  }//GEN-LAST:event_rbIgnoreActionPerformed

  private void rbCheckoutModuleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbCheckoutModuleActionPerformed
// Add your handling code here:
      tblModules.setEnabled(true);
  }//GEN-LAST:event_rbCheckoutModuleActionPerformed

    private void cancelButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        validSelection = false;
        tblModules.getSelectionModel().clearSelection();
        closeDialog(null);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        validSelection = true;
        closeDialog(null);
    }//GEN-LAST:event_okButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog

    public boolean showDialog() {
        show();
        return validSelection;
    }
    
    public void calledAsCommand(boolean yeah) {
      if (yeah) {
          lblWarning.setVisible(false);
          lblOptions.setVisible(false);
          rbCheckoutModule.setVisible(false);
          rbIgnore.setVisible(false);
      } else {
          lblWarning.setVisible(true);
          lblOptions.setVisible(true);
          rbCheckoutModule.setVisible(true);
          rbIgnore.setVisible(true);
      }      
    }    

    public void waitingForModules() {
        statusLabel.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.waitingForModules"));
        /*
        if (waitDlg == null) {
          javax.swing.SwingUtilities.invokeLater(new Runnable () {
            public void run () {
              waitDlg = new InformationDialog(new java.awt.Frame(), true, "Please wait, modules are loading ...");
              VcsUtilities.centerWindow(waitDlg);
              waitDlg.show();
            }
          });
    }
        */
    }

    /*
     * This method picks good column sizes.
     * If all column heads are wider than the column's cells' 
     * contents, then you can just use column.sizeWidthToFit().
     *
    private void initColumnSizes(JTable table, TableModel model) {
        TableColumn column = null;
        java.awt.Component comp = null;
        int headerWidth = 0;
        int cellWidth = 0;
        int columns = model.getColumnCount();
        
        for (int i = 0; i < columns; i++) {
            column = table.getColumnModel().getColumn(i);

            comp = column.getHeaderRenderer().
                             getTableCellRendererComponent(
                                 null, column.getHeaderValue(), 
                                 false, false, 0, 0);
            headerWidth = comp.getPreferredSize().width;
            /*
            comp = table.getDefaultRenderer(model.getColumnClass(i)).
                             getTableCellRendererComponent(
                                 table, model.getValueAt(, i),
                                 false, false, 0, i);
            cellWidth = comp.getPreferredSize().width;
            *
            column.setPreferredWidth(headerWidth); //Math.max(headerWidth, cellWidth));
        }
    }
     */

    public void setModules(Vector modules, boolean success) {
        this.modules = modules;
        //if (waitDlg != null) waitDlg.setVisible(false);
        if (success) statusLabel.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.modulesLoaded"));
        else statusLabel.setText(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.modulesLoadError"));
        if (modules == null || modules.size() == 0) {
            javax.swing.SwingUtilities.invokeLater(new Runnable() {
                                                       public void run() {
                                                           NotifyDescriptor nd = new NotifyDescriptor.Message (org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.noModules"));
                                                           TopManager.getDefault ().notify (nd);
                                                       }
                                                   });
              rbCheckoutModule.setEnabled(false);                                      
         //   closeDialog(null);
        } else {
            Vector columns = new Vector();
            columns.add(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.columnModule"));
            columns.add(org.openide.util.NbBundle.getBundle(CvsModuleSelectorDialog.class).getString("CvsModuleSelectorDialog.columnStatus"));
            DefaultTableModel model = new MyDefaultTableModel(modules, columns);
            TableSorter sorter = new TableSorter(model);
            tblModules.setModel(sorter);
            //tblModules.createDefaultColumnsFromModel();
            //initColumnSizes(tblModules, model);
            sorter.addMouseListenerToHeaderInTable(tblModules);
            sorter.sortByColumn(0, true); 
            //tblModules.revalidate();
            //tblModules.repaint();
            listScrollPane.validate();
            //pack();
        }
    }

    public String[] getSelection() {
        if (tblModules.getSelectedRowCount() == 0) {return null;}
        int[] select = tblModules.getSelectedRows();
        TableModel model = tblModules.getModel();
        Vector selStr = new Vector();
        for (int ind = 0; ind < select.length; ind++) {
            String mod = (String)model.getValueAt(select[ind], 0);
            selStr.add(mod);
        }    
        String[] modulesStrs = (String[]) selStr.toArray(new String[0]);
        return modulesStrs;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel statusLabel;
    private javax.swing.JScrollPane listScrollPane;
    private javax.swing.JTable tblModules;
    private javax.swing.JButton okButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel lblWarning;
    private javax.swing.JLabel lblOptions;
    private javax.swing.JRadioButton rbCheckoutModule;
    private javax.swing.JRadioButton rbIgnore;
    // End of variables declaration//GEN-END:variables
   
   class MyDefaultTableModel extends DefaultTableModel {
       
       static final long serialVersionUID = 4907156662613927521L;       

      public MyDefaultTableModel (Vector data, Vector columns) {
        super(data, columns);   
      }    
           
      public boolean isCellEditable(int row, int column) {
        return false;  
      }    
 
   }    
    
}

